<template>
  <Page>
    <ActionBar title="View event">
      <NavigationButton text="Go back" android.systemIcon="ic_menu_back" @tap="$navigateBack" />
    </ActionBar>
    <ScrollView>
      <StackLayout stretchLastChild="false" backgroundColor="#3c495e" class="overlay">
        <Label  placeholder="Event name" />
        <FloatingLabel :placeholder="currentEvent.name" />
        <Label text="Description" textWrap="true" />
        
        <FloatingLabel :placeholder="currentEvent.description" />
        <Label text="Date" />
        <FloatingLabel :placeholder="currentEvent.date" />
        <Label text="Time" />
        <FloatingLabel :placeholder="currentEvent.time" />
        
        <Button text="Manage event" @onTap="editEvent" v-if="isOwner" />
        <Button class="cancelBtn" color="white" text="Cancel event" @onTap="cancelEvent" v-if="isOwner" />
        <Button text="Join the event" @onTap="joinEvent" v-if="!isParticipating && !isOwner" />
        <Button text="Leave the event" @onTap="leaveEvent" v-if="isParticipating && !isOwner " />
      </StackLayout>
    </ScrollView>
  </Page>
</template>

<script>
import * as dialogs from "tns-core-modules/ui/dialogs";

import FloatingLabel from "./FloatingLabel";
import { mapGetters } from "vuex";
import { firestore } from "nativescript-plugin-firebase";

export default {
  props: ["eventId", ],
  data() {
    return {};
  },
  computed: {
    ...mapGetters({ user: "getUser", isLoading: 'isLoading', getEventById: "getEventById" }),
    isOwner: function() {
      return this.currentEvent.owner === this.user.uid
    },
    currentEvent: function() {
      return this.getEventById(this.eventId);
    },
    isParticipating: function() {
      return (
        this.currentEvent.participants.includes(this.user.uid)
      );
    }
  },
  methods: {
    editEvent() {
      console.log("edit event because youre the owner");
      alert("edit event because youre the owner");
    },
    async joinEvent() {
      if (this.isOwner || this.isParticipating) {
        alert("You cannot join your own event.");
      }
      const payload = {
        eventId: this.eventId,
        userId: this.user.uid
      };
      try {
        await this.$store.dispatch("joinEvent", payload);
        this.$navigateBack({clearHistory: true})
      } catch (e) {
        console.log("error happened when trying to add a participant");
        console.log(e);
        throw e;
      }
    },
    async leaveEvent() {
      const payload = {
        eventId: this.eventId,
        userId: this.user.uid
      };
      try {
        await this.$store.dispatch("leaveEvent", payload);
        this.$navigateBack({clearHistory: true})
      } catch (error) {
        console.log(error);
        throw error;
      }
    },
    async cancelEvent() {
      if (!this.isOwner) {
        return false;
      }
      const eventCanceled = dialogs.confirm(
        "Are you sure you want to cancel this event?",
        )
      // const eventCanceled = dialogs.confirm({
      //   title: "You are about to cancel your event",
      //   message: "Are you sure you want to cancel this event?",
      //   okButtonText: "Yes, delete",
      //   cancelButtonText: "No, keep it.",
      //   defaultText: "Default text",
      //   inputType: dialogs.inputType.text
      // });

      if (eventCanceled) {
        try {
          await this.$store.dispatch("cancelEvent", { eventId: this.eventId });
          this.$navigateBack({clearHistory: true})
          
        } catch (error) {
          console.log(error)
          alert(error)
          throw error
        }
      } else {
        console.log('no clicked');
        alert('There was a problem cancelling this event.')
      }
    }
  },
  components: { FloatingLabel }
};
</script>

<style scoped>
.cancelBtn {
  background-color: rgb(222, 20, 20);
  color: #ffffff;
}
</style>
